// -*- Mode:C++ -*-
//Header:
//File: cgaea.cc
//Title: gaea (C++ version)
//Author: NODA Itsuki
//Date: 1998/6/20
//EndHeader:

//ModifyHistory:
// 1998/6/20: Create this file
//EndModifyHistory:

//Memo:
//EndMemo:

//======================================================================
// Includes
//

#include <strings.h>
#include "base.h"
#include "thread_util.h"
#include "mmtoolT.h"
#include "ringT.h"
#include "gdata.h"
#include "gcell.h"
#include "gbio.h"
#include "gem.h"

#include "splayer.h"

//======================================================================
// Parameters
//

char* InitFile = "init.g" ;

#define ExecFileMax 64
UInt ExecFilesN = 0 ;
char* ExecFiles[ExecFileMax] ;

#define CallStrMax 64
UInt CallStrN = 0 ;
char* CallStr[CallStrMax] ;

char* MainGemName = "gem" ;

//======================================================================
// GetOptions
//

Int GetOption(int argc, char** argv) {
   Int c = 0 ;
   for(Int i = 1 ; i < argc ; i++) {
      if        (!strcmp(argv[i],"-e")) {
	 i++ ;
	 ExecFiles[ExecFilesN] = argv[i] ;
	 ExecFilesN++ ;
      } else if (!strcmp(argv[i],"-init")) {
	 i++ ;
	 InitFile = argv[i] ;
      } else if (!strcmp(argv[i],"-noinit")) {
	 InitFile = NULLPTR ;
      } else if (!strcmp(argv[i],"-call")) {
	 i++ ;
	 CallStr[CallStrN] = argv[i] ;
	 CallStrN++ ;
      } else {
	 cerr << "Unknown Option: " << argv[i] << endl ;
	 exit(1) ;
      }
   }
}


//======================================================================
// Main
//

int main(int argc, char** argv) {
   GetOption(argc,argv) ;

   gglobalInit() ;
   splayerInit() ;

   Gem gem(MainGemName,false) ;

   if(!isNullPtr(InitFile)) {
      gem.load(InitFile,BasicCell) ;
   }
   for(UInt i = 0 ; i < ExecFilesN ; i++) 
      gem.load(ExecFiles[i]) ;

   for(UInt i = 0 ; i < CallStrN ; i++) {
      istrstream istr(CallStr[i]) ;
      gem.loadloop(istr) ;
   }

   gem.reploop0(cin,cout) ;

   return 0 ;
}

