/*
 *  udp client program.
 */
#include <stdio.h>
#include <stdlib.h>

#include <libsclient.h>

#define MAXMESG 4096

void get_key(Socket *sock, char *tname, Side side)
{
     char c ;
     char buf[MAXMESG] ;
     int pos_x, pos_y ;
     SensorInfo info ;
     PosState pstate ;
     PosState pstate2 ;
     int i ;

     while(TRUE) {
	  c = (char)fgetc(stdin) ;
	  if (c == 'k')
	       send_com_dash(sock, 50) ;
	  else if (c == 'j')
	       send_com_dash(sock, -10) ;
	  else if (c == 'h')
	       send_com_turn(sock, -10) ;
	  else if (c == 'l')
	       send_com_turn(sock, 10) ;
	  else if (c == ' ')
	       send_com_kick(sock, 50, 0) ;
	  else if (c == 'm') {
	       printf("where to move? ") ;
	       scanf("%d %d", &pos_x, &pos_y) ;
	       printf("move to %f %f\n", (double)pos_x, (double)pos_y) ;
	       send_com_move(sock, (double)pos_x, (double)pos_y) ;
	  }
	  else if (c == 'p') {
	       if (receive_info(sock, buf, sizeof(buf)))
		    if (scan_info(buf, &info, tname))
			 if (estimate_current_pos(&(info.info.see), side, &pstate)) {
			      estimate_current_pos2(&(info.info.see), side, 
						    &pstate2) ;
			      printf("pos: (%f, %f), %f\n",
				     pstate.pos.x, pstate.pos.y, pstate.dir) ;
			      printf("pos2: (%f, %f), %f\n",
				     pstate2.pos.x, pstate2.pos.y, pstate2.dir) ;
			 }
			 else
			      printf("Can't estimate current pos.\n") ;
		    else
			 printf("Can't scan infomation\n") ;
	       else
		    printf("Can't reciev infomation\n") ;
	  }
	  else if (c == 'v') {
	       printf("range & quality? {nh|nl|h|l|wh|wl} ") ;
	       scanf("%s", buf) ;
	       if (!strcmp(buf, "nh")) {
		    send_com_change_view(sock, VW_Narrow, VQ_high) ;
		    printf("change view to Narrow High.\n ") ;
	       }
	       else if (!strcmp(buf, "nl")) {
		    send_com_change_view(sock, VW_Narrow, VQ_low) ;
		    printf("change view to Narrow Low.\n ") ;
	       }
	       else if (!strcmp(buf, "h")) {
		    send_com_change_view(sock, VW_Normal, VQ_high) ;
		    printf("change view to Normal High.\n ") ;
	       }
	       else if (!strcmp(buf, "l")) {
		    send_com_change_view(sock, VW_Normal, VQ_low) ;
		    printf("change view to Normal Low.\n ") ;
	       }
	       else if (!strcmp(buf, "wh")) {
		    send_com_change_view(sock, VW_Wide, VQ_high) ;
		    printf("change view to Wide High.\n ") ;
	       }
	       else if (!strcmp(buf, "wl")) {
		    send_com_change_view(sock, VW_Wide, VQ_low) ;
		    printf("change view to Wide Low.\n ") ;
	       }
	  }
	  else if (c == 's') {
	       printf("say message? >> ") ;
	       scanf("%s", buf) ;
	       send_com_say(sock, buf) ;
	  }
	  else if (c == 'q')
	       return ;
	  else if (c == '?') {
	       printf("avelable command is\n") ;
	       printf("  k : dash forward (pow is 50).\n") ;
	       printf("  j : dash backword (pow is 10).\n") ;
	       printf("  l : turn to left (angle is 10).\n") ;
	       printf("  h : turn to right (angle is 10).\n") ;
	       printf("  (space key) : kick a ball (power is 50).\n") ;
	       printf("  m : move.\n") ;
	       printf("  v : change view.\n") ;
	       printf("  s : say message.\n") ;
	       printf("  i : show infomation.\n") ;
	       printf("  p : estimate current position.\n") ;
	       printf("  ? : show this help.\n") ;
	       printf("  q : quit this program.\n") ;
	  }
	  else if (c == 'i') {
	       if (receive_info(sock, buf, sizeof(buf))) {
		    fputs(buf, stdout) ;
		    fflush(stdout) ;
		    if (scan_info(buf, &info, tname)) {
			 printf("success scan_info\n") ;
			 if (info.type == SIT_See) {
			      printf("  --- SEE INFO ---\n") ;
			      printf(" time: %d\n", info.info.see.time) ;
			      printf(" nobj: %d\n", info.info.see.n_obj) ;
			      for(i = 0; i < info.info.see.n_obj; i++) {
				   switch (info.info.see.obj[i].type) {
				   case OT_Ball:
					printf("  Obj is Ball\t") ;
					break ;
				   case OT_Player:
					printf("  Obj is Player\t") ;
					printf("team : %d\t",
					       info.info.see.obj[i].id.player.team) ;
					printf("unum : %d\t",
					       info.info.see.obj[i].id.player.unum) ;
					break ;
				   case OT_Goal:
					printf("  Obj is Goal\t") ;
					printf("side : %d\t",
					       info.info.see.obj[i].id.side) ;
					break ;
				   case OT_Flag:
					printf("  Obj is Flag\t") ;
					printf("fpos : %d\t",
					       info.info.see.obj[i].id.fpos) ;
					break ;
				   case OT_Line:
					printf("  Obj is Line\t") ;
					printf("lpos : %d\t",
					       info.info.see.obj[i].id.lpos) ;
					break ;
				   case OT_Unknown:
					printf("  Obj is Unknown\t") ;
				   }
				   printf("in?out: %d\t",
					  info.info.see.obj[i].inViewConeP) ;
				   printf("dist  : %f\t", info.info.see.obj[i].dist) ;
				   printf("dir   : %f\t", info.info.see.obj[i].dir) ;
				   if (info.info.see.obj[i].dist_chng != CHNG_ERR)
					printf("dist_c: %f\t",
					       info.info.see.obj[i].dist_chng) ;
				   if (info.info.see.obj[i].dist_chng != CHNG_ERR)
					printf("dir_c : %f\t",
					       info.info.see.obj[i].dir_chng) ;
				   printf("\n") ;
			      }
			 }
			 else if (info.type == SIT_Hear) {
			      printf("  --- HEAR INFO ---\n") ;
			      printf(" time : %d\n", info.info.hear.time) ;
			      printf(" type : %d\n", info.info.hear.sender) ;
			      printf(" dir  : %f\n", info.info.hear.direction) ;
			      printf(" mesg : %s\n", info.info.hear.message) ;
			 }
			 printf("\n") ;
		    }
		    else
			 printf("Can't scan_info\n") ;
	       }
	       else
		    printf("Can't receive infomation\n") ;
	  }
     }
}

void main(int argc, char **argv)
{
     Socket sock ;
     char *server ;
     int port ;
     InitInfo info ;
     char tname[16] ;

     if(argc == 4) {
	  strcpy(tname, argv[1]) ;
	  server = argv[2] ;
	  port = atoi(argv[3]) ;
     } else if (argc == 3) {
	  strcpy(tname, argv[1]) ;
	  server = argv[2] ;
	  port = 6000 ;
     } else if (argc == 2) {
	  strcpy(tname, argv[1]) ;
	  server = "localhost" ;
	  port = 6000 ;
     } else {
	  printf("usage: %s TEAMNAME [HOST [PORT]]\n", argv[0]) ;
	  exit(0) ;
     }

     sock = init_connection(server,port) ;
     if(sock.socketfd == -1)
	  exit(1) ;

     info = send_com_init(&sock, tname, TRUE, FALSE) ;

     printf("\ninit!: %d, %d, %s, %d\n\n",
	    info.side, info.unum, info.playmodestr, info.playmode) ;

     if (info.side == S_UNKNOWN) {
	  printf("Can't init\n") ;
	  exit(-1) ;
     }
     get_key(&sock, tname, info.side) ;

     close_connection(sock) ;
}

