// -*- Mode:C++ -*-
//Header:
//File: thread_util.h
//Author: NODA Itsuki
//Date: 1998/2/6
//EndHeader:

#ifndef _thread_util_h_
#define _thread_util_h_
////////////////////////////////////////////////////////////////////////
#include <stdlib.h>
#include <math.h>
#include <sys/time.h>
#include <sys/types.h>
#ifdef THREADED
#include <pthread.h>
#endif
#include <iostream.h>

#include "base.h"

//======================================================================
// SLEEP
//
extern void USleep(const UInt sec, const UInt usec) ;
extern void USleep(const UInt usec) ;

extern void MSleep(const UInt sec, const UInt msec) ;
extern void MSleep(const UInt msec) ;

extern void Sleep(const UInt sec) ;
extern void FSleep(const Float sec) ;

extern void SleepForever() ;

#ifdef Solaris
inline void Yield() { sched_yield() ;} ;
#else
inline void Yield() {} ;
#endif

//======================================================================
// CondBarrier
//
class CondBarrier {
   public:
      pthread_cond_t cond ;
      pthread_mutex_t mutex ;

      inline CondBarrier() {
	 pthread_cond_init(&cond, NULL) ;
	 pthread_mutex_init(&mutex, NULL) ;
      } ;

      inline void lock() {
	 pthread_mutex_lock(&mutex) ;
      } ;

      inline void unlock() {
	 pthread_mutex_unlock(&mutex) ;
      } ;
      
      inline void wait() {
	 pthread_cond_wait(&cond,&mutex) ;
      } ;

      inline void lockwait() {
	 pthread_mutex_lock(&mutex) ;
	 pthread_cond_wait(&cond,&mutex) ;
	 pthread_mutex_unlock(&mutex) ;
      } ;
      inline void signal() {
	  pthread_cond_broadcast(&cond) ;
//	 pthread_cond_signal(&cond) ;
      } ;
} ;

  
////////////////////////////////////////////////////////////////////////
#endif
