#define NULL 0
#include "mmtoolT.h"
#include "ringT.h"
#include "gdata.h"
#include "gcell.h"
#include "gbio.h"
#include "gem.h"

typedef AStack<GData> GDStack ;
typedef SpStack<GData> GDSpStack ;
typedef Ring<GData> GDRing ;

int test1() {
// GDStack GDS = GDStack("GDStack",100) ;
   GDSpStack GDS = GDSpStack("GDSpStack",100) ;

   Int dummy ;
//   cout << GDS << endl ;
   GDS.push(GInteger(1)) ;
   GDS.push(GSymbol("aho")) ;
   GDS.push(GFloat(1.23)) ;
   GDS.push(GTerm(FindSymbol("aho"),GInteger(2),GFloat(3.0))) ;
   GDS.describe(cout) ;
   cout << GDS.pop() << endl ;
   cout << GDS.pop() << endl ;
   cout << GDS.pop() << endl ;
   cout << GDS.pop() << endl ;
//   cout << GDS << endl ;
   GDS.describe(cout,false) ;
} 

int test2() {
   PRHeap<GData> foo ;
   foo.describe(cout) ;
   
}

int test3() {
   GSymbol GNullSym = GSymbol("null") ;
   GDRing GDR = GDRing(GNullSym,true) ;
   GDR.describe(cout,true) ;

   cout << GDR << endl;
   
   GDR.insertFirst(GSymbol("baka")) ; 
   GDR.insertLast(GInteger(1));
   GDR.insertFirst(GFloat(1.5));
   GDR.describe(cout,true) ;
   GDR.remove(GDR.next->next) ;
   GDR.describe(cout,true) ;
}

int test4() {
   GCell Gcell0 = GCell(GSymbol("aho")) ;
   GCell Gcell1 = GCell(GSymbol("baka")) ;
   GCell Gcell2 = GCell(GSymbol("boke")) ;

   GData gcl1 = readGData("$rule(a(1),b(2))") ;
   GData gcl2 = readGData("$fact(b(2))") ;
   GData gcl3 = readGData("$rule(b(X),$and(c(X),d(X)))") ;

   cout << gcl1 << endl ;
   cout << gcl2 << endl ;
   cout << gcl3 << endl ;

   Gcell0.asserta(GClause(gcl1)) ;
   Gcell0.asserta(GClause(gcl2)) ;
   Gcell0.assertz(GClause(gcl3)) ;

   Gcell0.pushGCell(&Gcell1) ;
   Gcell0.pushGCell(&Gcell1) ;
   Gcell1.pushGCell(&Gcell2) ;

   Gcell0.describe(cout,true) ;
   Gcell0.showGCellStack(cout,true) ;

   Gcell1.assertz(GClause(readGData("$rule(b(X),$and(e(X),f(X)))"))) ;
   Gcell1.assertz(GClause(readGData("$fact(a(5))"))) ;

   cout << Gcell1 << endl << endl;

   GClausePointer gcp = GClausePointer(&Gcell0) ;
   
   gcp.describe(cout,true) ; cout << endl ;

   GClauseRing* gcr = gcp.findGClause(GTermHeadArity(readGData("b(X)"))) ;
   gcp.describe(cout,true) ;
   cout << *gcr << endl << endl ;

   gcr = gcp.findGClause(GTermHeadArity(readGData("b(X)"))) ;
   gcp.describe(cout,true) ;
   cout << *gcr << endl << endl ;

   gcr = gcp.findGClause(GTermHeadArity(readGData("b(X)"))) ;
   gcp.describe(cout,true) ;
   cout << *gcr << endl << endl ;

   gcr = gcp.findGClause(GTermHeadArity(readGData("b(X)"))) ;
   gcp.describe(cout,true) ;
   if(isNullPtr(gcr)) { cout << "Fail!" << endl << endl ; }
   else {  cout << *gcr << endl << endl ; }
   
}

int test5() {
   Gem gem("noda") ;

   cout << gem << endl;
   gem.describe(cout) ;
//   gem.traceon(Gem::TRC_kernel) ;

//   gem.gcell->assertz(GClause(readGData("$rule(a(X),b(X))"))) ;
   gem.gcell->assertz(GClause(readGData("$rule(a(X),$and(b(X)))"))) ;
   gem.gcell->assertz(GClause(readGData("$fact(b(1,2))"))) ;
   gem.gcell->assertz(GClause(readGData("$fact(b(3))"))) ;

   gem.gcell->assertz(GClause(readGData("$fact(app(nil,T,T))"))) ;
   gem.gcell->assertz(GClause(readGData("$rule(app($cons(H,B),T,
   					           $cons(H,R)),
                                               app(B,T,R))"))) ;

   gem.gcell->describe(cout,true) ;
   
   gem.settopgoal(readGData("a(Y)")) ;
   gem.describe(cout,true) ;

   if(gem.unfoldLoop()) 
      cout << "Success!" << endl ;
   else
      cout << "Fail!" << endl ;
}
int test6() {
   Gem gem("noda") ;
 
   gem.reploop0(cin,cout) ;
   
}

//////////////////////////////////////////////////////////////////////
int main(int argc, char** argv) {
   gglobalInit() ;

//   test1() ;
//   test2() ;
//   test3() ;
//   test4() ;
   
//   test5() ;
   test6() ;

   return 0 ;
}

